<template>
  <div class="h-screen overflow-auto bg-img">
    <div class="flex flex-col gap-5">
      <div class="flex justify-center mt-14 md:mt-0">
        <img
          :src="logo.ImagePath"
          alt="logo"
          style="width: 23.466vw; height: auto"
        />
      </div>
      <div
        class="flex justify-center items-center gap-5 text-white mt-2 text-[3.8vw]"
      >
        <div class="flex items-center border-across-title">
          <span class="text-[15.83px] px-5">{{ $t("sponsors") }}</span>
        </div>
      </div>
      <div
        class="grid grid-cols-3 gap-5 px-12"
        style="width: 100%; height: auto"
      >
        <div
          v-for="sponsor in sponsors"
          :key="sponsor.HtmlId"
          class="flex flex-col items-center justify-between"
        >
          <img
            :src="sponsor.ImagePath"
            alt="logo"
            style="width: 60%; height: auto"
          />
          <div class="p-2 text-center text-white">
            <div class="text-[3.8vw]">{{ sponsor.Text }}</div>
          </div>
        </div>
      </div>
      <login-component
        v-if="isLogin"
        :show="isLogin === true"
        @toggleRegister="toggleRegister"
      />
      <register-component
        v-if="!isLogin && !register.IsHidden"
        :show="isLogin === false"
        :is-show-term="
          !termConditionHeader.IsHidden && !termConditionContent.IsHidden
        "
        @toggleRegister="toggleRegister"
        @toggle-terms="toggleTerms"
      />
    </div>
    <el-dialog
      v-model="isShowTerms"
      :lock-scroll="true"
      width="100%"
      :show-close="false"
    >
      <template #title class="bg-white">
        <div
          class="flex items-center justify-center font-bold text-blue-600 header-title"
        >
          <p class="text-lg">{{ termConditionHeader.Text }}</p>
        </div>
      </template>
      <div
        class="text-black content-body h-[80vh] overflow-y-auto"
        style="padding-bottom: 150px"
        v-html="termConditionContent.Text"
      ></div>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, onBeforeMount, computed } from "vue";
import { useRouter } from "vue-router";
import LoginComponent from "./LoginComponent.client.vue";
import RegisterComponent from "./RegisterComponent.client.vue";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";

export default defineComponent({
  name: "AuthViewWrapper",
  components: {
    LoginComponent,
    RegisterComponent,
  },
  setup() {
    const router = useRouter();
    const isLogin = ref(false);
    const isShowTerms = ref(false);

    const toggleRegister = () => {
      if (isLogin.value) {
        router.push("/register");
      } else {
        router.push("/login");
      }
    };

    onBeforeMount(() => {
      const isLoginRoute =
        router.currentRoute.value.path.toLowerCase() === "/login";
      if (isLoginRoute) {
        isLogin.value = true;
      } else {
        isLogin.value = false;
      }
    });

    const toggleTerms = () => {
      isShowTerms.value = !isShowTerms.value;
    };
    const { getAssetImage } = commonHelper;
    const bgImg = `url(${getAssetImage(
      "assets/theme/light_flexible_1/mobile/images/lfm1_background_image.png"
    )}`;
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const sponsors = computed(
      (): Array<IThemePropertiesFromApi> =>
        themePropertyHelper.getMultipleThemesProperties(
          themeProperties.value,
          "index_blog_1_"
        )
    );
    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "logo"
        )
    );
    const register = computed(() =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "register"
      )
    );
    const termConditionContent = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "menu_content_2_1"
        )
    );
    const termConditionHeader = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "footer_menu_info_2"
        )
    );
    return {
      isLogin,
      isShowTerms,
      toggleRegister,
      toggleTerms,
      getAssetImage,
      bgImg,
      sponsors,
      logo,
      register,
      termConditionContent,
      termConditionHeader,
    };
  },
});
</script>
<style scoped>
:deep(.el-input__inner) {
  --el-input-text-color: white;
}

:deep(.el-dialog__header) {
  position: sticky;
  box-shadow: 0px 5px 17px -15px #111;
  background: var(--background1);
  margin: unset;
}

:deep(.el-dialog__body) {
  background: var(--background1);
  font-size: 16px;
}

:deep(button.el-button) {
  width: 100%;
  border: none;
}

:deep(.el-button.is-disabled) {
  --el-button-disabled-bg-color: #0ea5e9;
  --el-button-disabled-border-color: var(--border);
  opacity: 0.5;
  @apply bg-gradient-to-r from-sky-500 to-indigo-500;
}
.bg-img {
  background-image: v-bind("bgImg");
  background-size: cover;
  height: 100vh;
  position: fixed;
  top: 0;
  bottom: 0;
  width: 100vw;
  z-index: -1;
}
.border-across-title::before,
.border-across-title::after {
  content: "";
  position: relative;
  display: table-cell;
  width: 15vw;
  border-top: 1px solid #f7f7f954;
}
.login-btn {
  opacity: 0.5;
}
:deep(.el-input .el-input__inner) {
  --el-input-border-color: transparent;
  --el-input-hover-border-color: transparent;
  --el-input-focus-border-color: transparent;
}
:deep(.is-error .el-input) {
  box-shadow: none;
}
:deep(.el-form-item.is-error .el-input__inner) {
  box-shadow: none;
}
:deep(.el-select .el-input.is-focus .el-input__inner) {
  box-shadow: none !important;
}
:deep(.el-select .el-input__inner:focus) {
  box-shadow: none !important;
}
:deep(.el-input span) {
  font-size: 24px;
  color: white;
}
:deep(.el-dialog) {
  height: 90vh;
  overflow: hidden;
  --el-dialog-margin-top: 10vh;
  --el-dialog-margin-bottom: 0px;
  border-top-left-radius: 0.5rem;
  border-top-right-radius: 0.5rem;
  margin: var(--el-dialog-margin-top, 15vh) auto 0px;
}
:deep(.dialog-fade-enter-active) {
  background: transparent;
  animation: fadeUpRight 0.6s ease backwards;
  opacity: 0;
}
:deep(.dialog-fade-leave-active) {
  background: transparent;
  animation: fadeDownLeft 0.8s ease backwards;
}
:deep(.el-input__inner) {
  background-color: transparent;
  height: 24px;
}
:deep(.el-form-item) {
  margin-bottom: 0;
}
:deep(.el-form-item__label) {
  color: white;
  font-weight: bold;
  font-size: 0.975rem;
}
:deep(.el-button) {
  @apply h-[13.5vw];
}
:deep(
    .el-input__inner:-webkit-autofill,
    .el-input__inner:-webkit-autofill:hover,
    .el-input__inner:-webkit-autofill:focus,
    .el-input__inner:-webkit-autofill:active
  ) {
  transition: background-color 50000s ease-in-out 0s, color 5000s ease-in-out 0s;
  -webkit-text-fill-color: #fff;
}
:deep(.el-button.el-button--danger) {
  --el-button-bg-color: green;
}
.fadeInLeft {
  animation: fadeInLeft 1.2s ease backwards;
}
@keyframes fadeInLeft {
  0% {
    transform: translate(500px, 0);
    opacity: 0;
  }
  100% {
    transform: translate(0, 0);
    opacity: 1;
  }
}
.fadeInRight {
  animation: fadeInRight 1.2s ease backwards;
}
@keyframes fadeInRight {
  0% {
    transform: translate(-500px, 0);
    opacity: 0;
  }
  100% {
    transform: translate(0, 0);
    opacity: 1;
  }
}
@keyframes fadeUpRight {
  0% {
    transform: translate(-500px, 900px);
    opacity: 0;
  }
  100% {
    transform: translate(0, 0);
    opacity: 1;
  }
}
@keyframes fadeDownLeft {
  0% {
    transform: translate(0, 0);
    opacity: 1;
  }
  100% {
    transform: translate(-500px, 900px);
    opacity: 0;
  }
}
:deep(.captcha-dialog-container .el-dialog) {
  height: 230px;
}

:deep(.captcha-dialog-container .el-input) {
  @apply bg-black/25;
}
</style>
